//+------------------------------------------------------------------+
//|                                            double smooth ema.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  1
#property indicator_color1  Aqua
#property indicator_width1 2
//
//
//
//
//

extern int emaPeriod = 10;//**********************
extern int emaPrice  = PRICE_CLOSE;

//
//
//
//
//

double emaBuffer[];
double wrkBuffer[];
double alpha;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,emaBuffer);
   SetIndexBuffer(1,wrkBuffer);
   emaPeriod = MathMax(emaPeriod,1);
       alpha = 2.0 /(1.0+MathSqrt(emaPeriod));
   
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,emaPrice,i);//***********?????????????
         if (i==Bars-1)
         {
            emaBuffer[i] = price;
            wrkBuffer[i] = price;
            continue;
         }
         
         wrkBuffer[i] = wrkBuffer[i+1] + alpha*(price       -wrkBuffer[i+1]);
         emaBuffer[i] = emaBuffer[i+1] + alpha*(wrkBuffer[i]-emaBuffer[i+1]);
   }
   return(0);
}